                 (* +----------------------------+
                    |  Segmentation d'une liste  |
                    +----------------------------+ *)

(* dcoupage *)
let rec dcoupe l p = match l with
  | [] -> [],[]
  | a::suite -> let (l1,l2) = dcoupe suite p in
                if a < p then (a::l1,l2) else (l1,a::l2)
;;

let rec dcoupe_strict l p = match l with
  | [] -> [],[],0
  | a::suite -> let (l1,l2,n) = dcoupe_strict suite p in
                     if a < p then (a::l1,l2,n)
		else if a > p then (l1,a::l2,n)
		else               (l1,l2,n+1)
;;

(* essai *)
let rec random_list a b n = 
  if n=0 then []
  else (a + random__int(b-a)) :: (random_list a b (n-1))
;;

let l = random_list 0 10 20;;
dcoupe l 5;;
dcoupe_strict l 5;;

(* sans rptition *)
let rec est_sr l = match l with
  | [] | [_] -> true
  | x::suite -> let (l1,l2,n) = dcoupe_strict suite x in
                (n = 0) && (est_sr l1) && (est_sr l2)
;;

(* lment majoritaire *)
let rec majoritaire l = match l with
  | []  -> failwith "liste vide"
  | [x] -> (x,1)
  | x::suite -> let (l1,l2,n) = dcoupe_strict l x in
		let res = ref(x,n) in
		if l1 <> [] then begin
		  let (x1,n1) = majoritaire l1 in
		  if n1 > snd(!res) then res := (x1,n1)
		end;
		if l2 <> [] then begin
		  let (x2,n2) = majoritaire l2 in
		  if n2 > snd(!res) then res := (x2,n2)
		end;
		!res
;;

(* tri *)
let rec tri l = match l with
  | [] | [_] -> l
  | x::suite -> let (l1,l2) = dcoupe suite x in (tri l1) @ [x] @ (tri l2);;

let rec tri_sr l = match l with
  | [] | [_] -> l
  | x::suite -> let (l1,l2,_) = dcoupe_strict suite x in (tri_sr l1) @ [x] @ (tri_sr l2);;


(* k-me lment *)
let rec keme l k = match l with
  | [] -> failwith "rang incorrect"
  | [x] -> if k=1 then x else failwith "rang incorrect"
  | x::suite -> let (l1,l2) = dcoupe suite x in
                let k1 = list_length(l1)      in
		     if k <= k1 then keme l1 k
		else if k=k1+1  then x
		else                 keme l2 (k-k1-1)
;;

(* listes disjointes *)
let rec disjoint l1 l2 = match l1 with
  | [] -> true
  | x::suite -> let (l11,l12,_) = dcoupe_strict suite x in
                let (l21,l22,n) = dcoupe_strict l2    x in
                (n = 0) && (disjoint l11 l21) && (disjoint l12 l22)
;;
